library ieee;
use ieee.std_logic_1164.all;

entity seriale_parallelo is
	port (rst,clk, seriale: in std_logic;
	parallelo: out std_logic_vector(7 downto 0);
	pronto: out std_logic );
end seriale_parallelo;

architecture beh of seriale_parallelo is
type stati is (idle, b0,b1,b2,b3,b4,b5,b6,b7,update);
signal S,nextS : stati;
signal T: std_logic_vector(7 downto 0);
signal writeT,writeP: std_logic;
begin
	
	process(rst,clk)
	begin
		if rst = '1' then
			S <= idle;
		elsif clk'event and clk='0' then
			S <= nextS;
	    end if;
	end process;
	
	process(S,seriale)
	begin
		case S is
			when idle => if seriale = '0' then
				             nextS <= b0 after 1 ps;
			             else nextS <= idle;
						 end if;
		    when b0 => nextS<= b1 after 1 ps;
			when b1 => nextS<= b2 after 1 ps;
			when b2 => nextS<= b3 after 1 ps;
			when b3 => nextS<= b4 after 1 ps;
			when b4 => nextS<= b5 after 1 ps;
			when b5 => nextS<= b6 after 1 ps;
			when b6 => nextS<= b7 after 1 ps;
			when b7 => nextS<= update after 1 ps;
			when others => nextS <= idle after 1 ps;
		  end case;
		end process;
	
		process(S)
		begin
			if S=idle or S=update then
				writeT<= '0';
			else writeT <= '1';
			end if;
		    if S=update then
				writeP <= '1' after 1 ps;
			else writeP<= '0' after 1 ps;
			end if;
		
		end process;

		datapath:
		process(clk,rst)
		begin
			if rst ='1' then
				T<= (others => '0');
			elsif clk'event and clk='0' then
				if writeT ='1' then
					T<= T(6 downto 0)&seriale;
				end if;
				if writeP = '1' then
					parallelo<=T;
				end if;
				
				pronto<= writeP;
			end if;
	end process;
end beh;
			
			
			