library ieee;
use ieee.std_logic_1164.all;

entity seriale_parallelo2 is
	port (rst,clk, seriale: in std_logic;
	parallelo: out std_logic_vector(7 downto 0);
	pronto: out std_logic );
end seriale_parallelo2;

architecture beh of seriale_parallelo2 is
type stati is (idle, leggi,update);
signal S,nextS : stati;			 
signal conta: integer range 0 to 7;
signal T: std_logic_vector(7 downto 0);
signal writeT,writeP: std_logic;
begin
	
	process(rst,clk)
	begin
		if rst = '1' then
			S <= idle;
		elsif clk'event and clk='0' then
			S <= nextS;
	    end if;
	end process;
	
	process(S,seriale,conta)
	begin
		case S is
			when idle => if seriale = '0' then
				            nextS <= leggi;
						 else nextS <= idle;
						 end if;
		    when leggi => if conta <7 then
				             nextS<= leggi;
							 
			              else nextS<= update; 
						  end if;
			when others => nextS <= idle;
		  end case;
		end process;
	
		process(S)
		begin
			if S=leggi  then
				writeT<= '1';
			else writeT <= '0';
			end if;
		    if S=update then
				writeP <= '1' after 1 ps;
			else writeP<= '0' after 1 ps;
			end if;
		
		end process;

		datapath:
		process(clk,rst)
		begin
			if rst ='1' then
				T<= (others => '0');
				conta<= 0;
			elsif clk'event and clk='0' then
				if writeT ='1' then
					T<= T(6 downto 0)&seriale;
					if conta < 7 then
						conta<= conta+1;
					end if;
				end if;
				if writeP = '1' then
					parallelo<=T;  
					conta<= 0;
				end if;
				
				pronto<= writeP;
			end if;
	end process;  
	
	
end beh;
			
			
			